package particles;
import java.awt.Color;

/* Type representing a particle system: a collection of particles that can
 * be moved around the screen.
 */
public class ParticleSystem {
    /* Dimensions of a graphics scene. Particles that move outside the bounding
     * box [0, SCENE_WIDTH) x [0, SCENE_HEIGHT) disappear.
     */
    public static final double SCENE_WIDTH  = 800;
    public static final double SCENE_HEIGHT = 600;

    /* Doubly-linked list type used to represent a chain of particles. */
    static class Cell {
        public Particle particle;
        public Cell next, prev;
    }
    
    /* The first cell in the list of particles, or null if there are no particles. */
    Cell head;

    /* Creates a new, empty particle system. You may need to fill this method in with
     * initialization code, or you may not need to put anything here. It all depends
     * on your implementation.
     */
    public ParticleSystem() {
        /* TODO: Delete this comment and implement this method. */
    }

    /* Adds a new particle to the scene. If the particle is out of bounds or
     * has a negative lifetime, has no effect. The particle is placed at
     * the end of the list of particles, and this method runs in time O(1).
     */
    public void add(Particle particle) {
        /* TODO: Delete this comment and implement this method. */
    }

    /* Returns how many particles are in the particle system. Runs in time
     * O(1).
     */
    public int numParticles() {
        /* TODO: Delete this comment and implement this method. */
        return -1;
    }

    /* Draws all the particles in the system. */
    public void drawParticles(ParticleGraphics graphics) {
        /* TODO: Delete this comment and implement this method. */
    }

    /* Moves all particles in the system. This may cause some particles
     * to be removed (if their lifetimes end or the particles move out of
     * bounds) or added (if firework particles explode).
     */
    public void moveParticles() {
        /* TODO: Delete this comment and implement this method. */
    }
}
